## igraph 0.9.6%2Bds

=== CMakeLists.txt ===
# Minimum CMake that we require is 3.16 because we use --ignore-eol when
# comparing unit test results with expected outcomes (added in 3.14) and we
# also use SKIP_REGULAR_EXPRESSION to handle skipped tests properly
cmake_minimum_required(VERSION 3.16)

# Add etc/cmake to CMake's search path so we can put our private stuff there
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/etc/cmake)

# Set a default build type if none was specified
# This must precede the project() line, which would set the CMAKE_BUILD_TYPE
# to 'Debug' with single-config generators on Windows.
# Note that we must do this only if PROJECT_NAME is not set at this point. If
# it is set, it means that igraph is being used as a subproject of another
# project.
if(NOT PROJECT_NAME)
  include(BuildType)
endif()

# Prevent in-source builds
include(PreventInSourceBuilds)

# Make use of ccache if it is present on the host system -- unless explicitly
# asked to disable it
include(UseCCacheWhenInstalled)

# Figure out the version number from Git
include(version)

# Declare the project, its version number and language
project(
  igraph
  VERSION ${PACKAGE_VERSION_BASE}
  DESCRIPTION "A library for creating and manipulating graphs"
  HOMEPAGE_URL https://igraph.org
  LANGUAGES C CXX
)

# Include some compiler-related helpers and set global compiler options
include(compilers)

# Set default symbol visibility to hidden
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# Set C and C++ standard version
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Expose the BUILD_SHARED_LIBS option in the ccmake UI
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

# Add switches to use sanitizers and debugging helpers if needed
include(debugging)
include(sanitizers)

# Add version information
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_version.h
)

# Create configuration options for optional features
include(features)

# Handle dependencies and dependency-related configuration options
include(dependencies)
find_dependencies()

# Run compile-time checks, generate config.h and igraph_threading.h
include(CheckSymbolExists)

# First we check for some functions and symbols
set(CMAKE_REQUIRED_LIBRARIES_SAVE ${CMAKE_REQUIRED_LIBRARIES})
if(NEED_LINKING_AGAINST_LIBM)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
endif()
check_symbol_exists(expm1 math.h HAVE_EXPM1)
check_symbol_exists(fmin math.h HAVE_FMIN)
check_symbol_exists(finite math.h HAVE_FINITE)
check_symbol_exists(isfinite math.h HAVE_ISFINITE)
check_symbol_exists(log2 math.h HAVE_LOG2)
check_symbol_exists(log1p math.h HAVE_LOG1P)
check_symbol_exists(rint math.h HAVE_RINT)
check_symbol_exists(rintf math.h HAVE_RINTF)
check_symbol_exists(round math.h HAVE_ROUND)
check_symbol_exists(stpcpy string.h HAVE_STPCPY)
check_symbol_exists(strcasecmp strings.h HAVE_STRCASECMP)
check_symbol_exists(strdup string.h HAVE_STRDUP)
check_symbol_exists(_stricmp string.h HAVE__STRICMP)
set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES_SAVE})

# Check for code coverage support
option(IGRAPH_ENABLE_CODE_COVERAGE "Enable code coverage calculation" OFF)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND IGRAPH_ENABLE_CODE_COVERAGE)
  include(CodeCoverage)
  append_coverage_compiler_flags()
  setup_target_for_coverage_lcov(
    NAME coverage
    EXECUTABLE "${CMAKE_COMMAND}" "--build" "${PROJECT_BINARY_DIR}" "--target" "check"
    # Generated files are excluded; apparently the CodeCoverage script has some
    # problems with them. Yes, the exclusion is correct, it refers to a nonexistent
    # directory that somehow gets into the coverage resolts. /Applications is for
    # macOS -- it excludes files from the macOS SDK.
    EXCLUDE "io/*.l" "io/parsers/*" "/Applications/Xcode*" "examples/*" "tests/*"
  )
endif()

# Generate configuration headers
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_threading.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_threading.h
)

# Enable unit tests. Behave nicely and do this only if we are not being
# included as a sub-project in another CMake project
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  include(CTest)
  configure_file(
    ${PROJECT_SOURCE_DIR}/etc/cmake/CTestCustom.cmake.in
    ${PROJECT_BINARY_DIR}/CTestCustom.cmake
  )
endif()

# Traverse subdirectories. vendor/ should come first because code in
# src/CMakeLists.txt depends on targets in vendor/
add_subdirectory(vendor)
add_subdirectory(src)
add_subdirectory(interfaces)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
  add_subdirectory(tests)
endif()
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  add_subdirectory(doc)
endif()

# Configure packaging -- only if igraph is the top-level project and not a
# subproject
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  include(packaging)
endif()

# Show result of configuration
include(summary)

## igraph 0.9.6+ds

=== doc/CMakeLists.txt ===
# Specify the list of .xml files that are used as-is
set(
  DOCBOOK_SOURCES
  fdl.xml
  gpl.xml
  igraph-docs.xml
  installation.xml
  introduction.xml
  licenses.xml
  pmt.xml
  tutorial.xml
)

# Specify the list of .xxml files that have to be piped through doxrox to
# obtain the final set of .xml files that serve as an input to DocBook
set(
  DOXROX_SOURCES
  adjlist.xxml
  arpack.xxml
  attributes.xxml
  basicigraph.xxml
  bipartite.xxml
  cliques.xxml
  coloring.xxml
  community.xxml
  cycles.xxml
  dqueue.xxml
  embedding.xxml
  error.xxml
  flows.xxml
  foreign.xxml
  generators.xxml
  graphlets.xxml
  heap.xxml
  hrg.xxml
  isomorphism.xxml
  iterators.xxml
  layout.xxml
  matrix.xxml
  memory.xxml
  motifs.xxml
  nongraph.xxml
  operators.xxml
  progress.xxml
  psumtree.xxml
  random.xxml
  scg.xxml
  separators.xxml
  sparsemat.xxml
  sparsematrix.xxml
  spatialgames.xxml
  stack.xxml
  status.xxml
  structural.xxml
  strvector.xxml
  threading.xxml
  vector.xxml
  visitors.xxml
)

# Specify the igraph source files that may contain documentation chunks
file(
  GLOB_RECURSE IGRAPH_SOURCES_FOR_DOXROX
  LIST_DIRECTORIES FALSE
  ${CMAKE_SOURCE_DIR}/include/*.h
  ${CMAKE_SOURCE_DIR}/include/*.h.in
  ${CMAKE_BINARY_DIR}/include/*.h
  ${CMAKE_SOURCE_DIR}/src/*.c
  ${CMAKE_SOURCE_DIR}/src/*.cc
  ${CMAKE_SOURCE_DIR}/src/*.cpp
  ${CMAKE_SOURCE_DIR}/src/*.h
  ${CMAKE_SOURCE_DIR}/src/*.pmt
)

# Specify the igraph source files that are used as examples in the
# documentation
file(
  GLOB DOCBOOK_EXAMPLES
  LIST_DIRECTORIES FALSE
  RELATIVE ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/examples/simple/*.c
  ${CMAKE_SOURCE_DIR}/examples/tutorial/*.c
)

# You should not need to change anything below this line if you are simply
# trying to add new files to produce documentation from

# Documentation build requires Python and source-highlight
find_package(Python3)
find_program(SOURCE_HIGHLIGHT_COMMAND source-highlight)

# HTML documentation additionally requires xmlto from DocBook
find_program(XMLTO_COMMAND xmlto)

# PDF documentation additionally requires xsltproc, xmllint and Apache FOP
find_program(FOP_COMMAND fop)
find_program(XMLLINT_COMMAND xmllint)
find_program(XSLTPROC_COMMAND xsltproc)

if(Python3_FOUND AND SOURCE_HIGHLIGHT_COMMAND)
  set(DOC_BUILD_SUPPORTED TRUE)
else()
  set(DOC_BUILD_SUPPORTED FALSE)
endif()

if(DOC_BUILD_SUPPORTED AND XMLTO_COMMAND)
  set(HTML_DOC_BUILD_SUPPORTED TRUE)
else()
  set(HTML_DOC_BUILD_SUPPORTED FALSE)
endif()

if(DOC_BUILD_SUPPORTED AND XMLLINT_COMMAND AND XSLTPROC_COMMAND AND FOP_COMMAND)
  set(PDF_DOC_BUILD_SUPPORTED TRUE)
else()
  set(PDF_DOC_BUILD_SUPPORTED FALSE)
endif()

if(DOC_BUILD_SUPPORTED)
  set(DOXROX_COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doxrox.py)
  set(DOXROX_RULES ${CMAKE_CURRENT_SOURCE_DIR}/c-docbook.re)
  set(DOXROX_CHUNKS ${CMAKE_CURRENT_BINARY_DIR}/chunks.pickle)
  set(DOXROX_CACHE ${CMAKE_CURRENT_BINARY_DIR}/doxrox.cache)

  set(DOCBOOK_INPUTS "")
  set(DOCBOOK_GENERATED_INPUTS "")

  # Specify that each DocBook .xml file is to be copied to the build folder
  # TODO(ntamas): currently this works with out-of-tree builds only
  set(IGRAPH_VERSION ${PACKAGE_VERSION})   # for replacement in igraph-docs.xml
  foreach(DOCBOOK_SOURCE ${DOCBOOK_SOURCES})
    set(DOCBOOK_INPUT "${CMAKE_CURRENT_BINARY_DIR}/${DOCBOOK_SOURCE}")
    list(APPEND DOCBOOK_INPUTS "${DOCBOOK_INPUT}")
    configure_file(${DOCBOOK_SOURCE} ${DOCBOOK_INPUT})
  endforeach()

  # Specify that .xxml files should be piped through doxrox.py to get a
  # DocBook-compatible .xml file. This step inserts the documentation chunks
  # extracted from the igraph source to the DocBook sources
  foreach(DOXROX_SOURCE ${DOXROX_SOURCES})
    string(REGEX REPLACE "[.]xxml$" ".xml" DOXROX_OUTPUT ${DOXROX_SOURCE})
    set(COMMENT "Generating ${DOXROX_OUTPUT} from ${DOXROX_SOURCE}")

    string(PREPEND DOXROX_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/")
    list(APPEND DOCBOOK_INPUTS "${DOXROX_OUTPUT}")
    list(APPEND DOCBOOK_GENERATED_INPUTS "${DOXROX_OUTPUT}")

    add_custom_command(
      OUTPUT ${DOXROX_OUTPUT}
      COMMAND ${DOXROX_COMMAND}
      ARGS
      -t ${CMAKE_CURRENT_SOURCE_DIR}/${DOXROX_SOURCE}
      --chunks ${DOXROX_CHUNKS}
      -o ${DOXROX_OUTPUT}
      MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/${DOXROX_SOURCE}
      DEPENDS ${DOXROX_CHUNKS}
      COMMENT ${COMMENT}
    )
  endforeach()

  # When all .xxml and .xml files have been processed, we have to send them
  # through a custom Python script that extracts the ID references and produces
  # a ctags-compatible "tags" file. This will then be used later by
  # source-highlight to cross-reference the known tokens from the source code
  # of the examples
  list(JOIN DOCBOOK_GENERATED_INPUTS ";" DOCBOOK_GENERATED_INPUTS_AS_STRING)
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/tags"
    COMMAND ${CMAKE_COMMAND}
    ARGS
    -DINPUT_FILES="${DOCBOOK_GENERATED_INPUTS_AS_STRING}"
    -DOUTPUT_FILE=${CMAKE_CURRENT_BINARY_DIR}/tags
    -P ${CMAKE_SOURCE_DIR}/etc/cmake/generate_tags_file.cmake
    DEPENDS ${DOCBOOK_GENERATED_INPUTS}
    COMMENT "Creating tags file from DocBook xmls"
  )

  # Specify that each example source file is to be piped through source-higlight
  # to produce an .xml representation that can be used in the DocBook
  # documentation
  foreach(DOCBOOK_EXAMPLE_SOURCE ${DOCBOOK_EXAMPLES})
    string(REGEX REPLACE "[.]c$" ".c.xml" DOCBOOK_EXAMPLE_OUTPUT ${DOCBOOK_EXAMPLE_SOURCE})
    set(COMMENT "Highlighting source code in ${DOCBOOK_EXAMPLE_SOURCE}")

    set(DOCBOOK_EXAMPLE_OUTPUT "${CMAKE_BINARY_DIR}/${DOCBOOK_EXAMPLE_SOURCE}.xml")
    list(APPEND DOCBOOK_INPUTS "${DOCBOOK_EXAMPLE_OUTPUT}")

    get_filename_component(DOCBOOK_EXAMPLE_OUTPUT_DIR "${DOCBOOK_EXAMPLE_OUTPUT}" DIRECTORY)

    add_custom_command(
      OUTPUT ${DOCBOOK_EXAMPLE_OUTPUT}
      COMMAND ${CMAKE_COMMAND} -E make_directory ${DOCBOOK_EXAMPLE_OUTPUT_DIR}
      COMMAND ${SOURCE_HIGHLIGHT_COMMAND}
      ARGS
      --src-lang c
      --out-format docbook
      --input ${CMAKE_SOURCE_DIR}/${DOCBOOK_EXAMPLE_SOURCE}
      --output ${DOCBOOK_EXAMPLE_OUTPUT}
      --gen-references inline
      --ctags=""
      --outlang-def ${CMAKE_SOURCE_DIR}/doc/docbook.outlang
      MAIN_DEPENDENCY ${CMAKE_SOURCE_DIR}/${DOCBOOK_EXAMPLE_SOURCE}
      DEPENDS tags
      COMMENT ${COMMENT}
    )
  endforeach()

  add_custom_command(
    OUTPUT ${DOXROX_CHUNKS} ${DOXROX_CACHE}
    COMMAND ${DOXROX_COMMAND}
    ARGS
    -e ${DOXROX_RULES}
    -o ${DOXROX_CHUNKS}
    --cache ${DOXROX_CACHE}
    ${IGRAPH_SOURCES_FOR_DOXROX}
    MAIN_DEPENDENCY ${DOXROX_RULES}
    DEPENDS ${IGRAPH_SOURCES_FOR_DOXROX}
    COMMENT "Parsing documentation chunks from source code"
  )

  if(HTML_DOC_BUILD_SUPPORTED)
    set(HTML_STAMP ${CMAKE_CURRENT_BINARY_DIR}/html/stamp)

    add_custom_command(
      OUTPUT ${HTML_STAMP}
      COMMAND ${XMLTO_COMMAND} -x ${CMAKE_CURRENT_SOURCE_DIR}/gtk-doc.xsl -o html xhtml igraph-docs.xml
      COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/html/*.css ${CMAKE_CURRENT_BINARY_DIR}/html
      COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/html/*.js ${CMAKE_CURRENT_BINARY_DIR}/html
      COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/html/*.png ${CMAKE_CURRENT_BINARY_DIR}/html
      COMMAND ${CMAKE_COMMAND} -E touch ${HTML_STAMP}
      MAIN_DEPENDENCY igraph-docs.xml
      DEPENDS ${DOCBOOK_INPUTS}
      COMMENT "Generating HTML documentation with xmlto"
    )

    add_custom_target(html DEPENDS ${HTML_STAMP})
    set(HTML_TARGET html)
  endif()

  if(PDF_DOC_BUILD_SUPPORTED)
    add_custom_command(
      OUTPUT igraph-docs-with-resolved-includes.xml
      COMMAND ${XMLLINT_COMMAND}
      ARGS
      --xinclude
      --output igraph-docs-with-resolved-includes-tmp.xml
      igraph-docs.xml
      COMMAND ${Python3_EXECUTABLE}
      ARGS
      ${CMAKE_SOURCE_DIR}/tools/removeexamples.py
      igraph-docs-with-resolved-includes-tmp.xml
      igraph-docs-with-resolved-includes.xml
      COMMAND ${CMAKE_COMMAND}
      ARGS
      -E remove igraph-docs-with-resolved-includes-tmp.xml
      MAIN_DEPENDENCY igraph-docs.xml
      DEPENDS ${DOCBOOK_INPUTS}
      COMMENT "Resolving includes in DocBook XML source"
    )

    add_custom_command(
      OUTPUT igraph-docs.fo
      COMMAND ${XSLTPROC_COMMAND}
      ARGS
      --output igraph-docs.fo
      --stringparam paper.type A4
      http://docbook.sourceforge.net/release/xsl/current/fo/docbook.xsl
      igraph-docs-with-resolved-includes.xml
      MAIN_DEPENDENCY igraph-docs-with-resolved-includes.xml
      COMMENT "Converting DocBook XML to Apache FOP format"
    )

    add_custom_command(
      OUTPUT igraph-docs.pdf
      COMMAND ${FOP_COMMAND}
      ARGS -fo igraph-docs.fo -pdf igraph-docs.pdf
      MAIN_DEPENDENCY igraph-docs.fo
      COMMENT "Generating PDF documentation with Apache FOP"
    )

    add_custom_target(pdf DEPENDS igraph-docs.pdf)
    set(PDF_TARGET pdf)
  endif()

  add_custom_target(doc DEPENDS ${HTML_TARGET} ${PDF_TARGET})
endif()

set(HTML_DOC_BUILD_SUPPORTED ${HTML_DOC_BUILD_SUPPORTED} PARENT_SCOPE)
set(PDF_DOC_BUILD_SUPPORTED ${PDF_DOC_BUILD_SUPPORTED} PARENT_SCOPE)

=== interfaces/CMakeLists.txt ===
# Check whether the user has Stimulus on its PATH
find_program(STIMULUS_COMMAND stimulus)

# Add a custom targer that checks functions.yaml and types.yaml
if(STIMULUS_COMMAND)
    add_custom_command(
        OUTPUT test_stimulus_specifications.cpp
        COMMAND ${STIMULUS_COMMAND}
            -l ci:validate
            -f ${CMAKE_CURRENT_SOURCE_DIR}/functions.yaml
            -t ${CMAKE_CURRENT_SOURCE_DIR}/types.yaml
            -o test_stimulus_specifications.cpp
        DEPENDS
            ${CMAKE_CURRENT_SOURCE_DIR}/functions.yaml
            ${CMAKE_CURRENT_SOURCE_DIR}/types.yaml
        COMMENT "Generating C++ checker for Stimulus function and type specifications..."
        USES_TERMINAL
    )
    add_executable(test_stimulus test_stimulus_specifications.cpp)
    target_include_directories(test_stimulus PRIVATE ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include)

    add_custom_target(
        check_stimulus
		COMMAND test_stimulus
        DEPENDS test_stimulus
        COMMENT "Running C++ checker for Stimulus function and type specifications..."
    )
endif(STIMULUS_COMMAND)

=== src/CMakeLists.txt ===

# Traverse subdirectories
add_subdirectory(centrality/prpack)
add_subdirectory(cliques/cliquer)
add_subdirectory(isomorphism/bliss)

# Generate lexers and parsers
set(PARSER_SOURCES)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/io/parsers)
foreach(FORMAT dl gml lgl ncol pajek)
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c)
    list(APPEND PARSER_SOURCES
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-lexer.c
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c
    )
  else()
    if (BISON_VERSION VERSION_GREATER_EQUAL 3)
      set(bison_no_deprecated -Wno-deprecated)
    endif()
    bison_target(
      ${FORMAT}_parser io/${FORMAT}-parser.y ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-parser.c
      COMPILE_FLAGS "--no-lines ${bison_no_deprecated}"
    )
    flex_target(
      ${FORMAT}_lexer io/${FORMAT}-lexer.l ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.c
      COMPILE_FLAGS "--noline"
      DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.h
    )
    add_flex_bison_dependency(${FORMAT}_lexer ${FORMAT}_parser)
    list(APPEND PARSER_SOURCES ${BISON_${FORMAT}_parser_OUTPUTS} ${FLEX_${FORMAT}_lexer_OUTPUTS})
  endif()
endforeach()
add_custom_target(parsersources SOURCES ${PARSER_SOURCES})

# Declare the files needed to compile the igraph library
add_library(
  igraph
  core/array.c
  core/buckets.c
  core/cutheap.c
  core/dqueue.c
  core/error.c
  core/estack.c
  core/fixed_vectorlist.c
  core/grid.c
  core/hashtable.c
  core/heap.c
  core/indheap.c
  core/interruption.c
  core/marked_queue.c
  core/matrix.c
  core/memory.c
  core/printing.c
  core/progress.c
  core/psumtree.c
  core/set.c
  core/sparsemat.c
  core/spmatrix.c
  core/stack.c
  core/statusbar.c
  core/strvector.c
  core/trie.c
  core/vector_ptr.c
  core/vector.c

  math/bfgs.c
  math/complex.c
  math/utils.c

  linalg/arpack.c
  linalg/blas.c
  linalg/eigen.c
  linalg/lapack.c

  random/random.c

  graph/adjlist.c
  graph/attributes.c
  graph/basic_query.c
  graph/cattributes.c
  graph/iterators.c
  graph/type_indexededgelist.c
  graph/visitors.c

  constructors/adjacency.c
  constructors/atlas.c
  constructors/basic_constructors.c
  constructors/de_bruijn.c
  constructors/famous.c
  constructors/full.c
  constructors/kautz.c
  constructors/lcf.c
  constructors/linegraph.c
  constructors/prufer.c
  constructors/regular.c

  games/barabasi.c
  games/callaway_traits.c
  games/citations.c
  games/correlated.c
  games/degree_sequence_vl/gengraph_box_list.cpp
  games/degree_sequence_vl/gengraph_degree_sequence.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_hash.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_optimized.cpp
  games/degree_sequence_vl/gengraph_mr-connected.cpp
  games/degree_sequence_vl/gengraph_powerlaw.cpp
  games/degree_sequence.c
  games/dotproduct.c
  games/erdos_renyi.c
  games/establishment.c
  games/forestfire.c
  games/grg.c
  games/growing_random.c
  games/islands.c
  games/k_regular.c
  games/preference.c
  games/recent_degree.c
  games/sbm.c
  games/static_fitness.c
  games/tree.c
  games/watts_strogatz.c

  centrality/betweenness.c
  centrality/centrality_other.c
  centrality/centralization.c
  centrality/closeness.c
  centrality/coreness.c
  centrality/prpack.cpp

  cliques/cliquer_wrapper.c
  cliques/cliques.c
  cliques/maximal_cliques.c
  cliques/glet.c

  community/community_misc.c
  community/edge_betweenness.c
  community/fast_modularity.c
  community/fluid.c
  community/infomap/infomap_FlowGraph.cc
  community/infomap/infomap_Greedy.cc
  community/infomap/infomap_Node.cc
  community/infomap/infomap.cc
  community/label_propagation.c
  community/leading_eigenvector.c
  community/leiden.c
  community/louvain.c
  community/modularity.c
  community/optimal_modularity.c
  community/spinglass/clustertool.cpp
  community/spinglass/NetDataTypes.cpp
  community/spinglass/NetRoutines.cpp
  community/spinglass/pottsmodel_2.cpp
  community/walktrap/walktrap_communities.cpp
  community/walktrap/walktrap_graph.cpp
  community/walktrap/walktrap_heap.cpp
  community/walktrap/walktrap.cpp

  connectivity/cohesive_blocks.c
  connectivity/components.c
  connectivity/separators.c

  flow/flow.c
  flow/st-cuts.c

  hrg/hrg_types.cc
  hrg/hrg.cc

  io/dimacs.c
  io/dl.c
  io/dot.c
  io/edgelist.c
  io/graphml.c
  io/gml-tree.c
  io/gml.c
  io/graphdb.c
  io/leda.c
  io/lgl.c
  io/ncol.c
  io/pajek.c
  ${PARSER_SOURCES}

  layout/circular.c
  layout/davidson_harel.c
  layout/drl/DensityGrid.cpp
  layout/drl/DensityGrid_3d.cpp
  layout/drl/drl_graph.cpp
  layout/drl/drl_graph_3d.cpp
  layout/drl/drl_layout.cpp
  layout/drl/drl_layout_3d.cpp
  layout/fruchterman_reingold.c
  layout/gem.c
  layout/graphopt.c
  layout/kamada_kawai.c
  layout/large_graph.c
  layout/layout_bipartite.c
  layout/layout_grid.c
  layout/layout_random.c
  layout/mds.c
  layout/merge_dla.c
  layout/merge_grid.c
  layout/reingold_tilford.c
  layout/sugiyama.c

  operators/add_edge.c
  operators/complementer.c
  operators/compose.c
  operators/connect_neighborhood.c
  operators/contract.c
  operators/difference.c
  operators/disjoint_union.c
  operators/intersection.c
  operators/misc_internal.c
  operators/permute.c
  operators/rewire.c
  operators/rewire_edges.c
  operators/simplify.c
  operators/subgraph.c
  operators/union.c

  paths/all_shortest_paths.c
  paths/bellman_ford.c
  paths/dijkstra.c
  paths/distances.c
  paths/eulerian.c
  paths/histogram.c
  paths/johnson.c
  paths/random_walk.c
  paths/shortest_paths.c
  paths/simple_paths.c
  paths/unweighted.c

  properties/basic_properties.c
  properties/constraint.c
  properties/convergence_degree.c
  properties/dag.c
  properties/degrees.c
  properties/girth.c
  properties/loops.c
  properties/multiplicity.c
  properties/neighborhood.c
  properties/spectral.c
  properties/trees.c
  properties/triangles.c

  scg/scg_approximate_methods.c
  scg/scg_exact_scg.c
  scg/scg_kmeans.c
  scg/scg_optimal_method.c
  scg/scg_utils.c
  scg/scg.c

  isomorphism/bliss.cc
  isomorphism/isoclasses.c
  isomorphism/lad.c
  isomorphism/isomorphism_misc.c
  isomorphism/queries.c
  isomorphism/vf2.c

  misc/bipartite.c
  misc/chordality.c
  misc/cocitation.c
  misc/coloring.c
  misc/conversion.c
  misc/degree_sequence.cpp
  misc/embedding.c
  misc/feedback_arc_set.c
  misc/graphicality.c
  misc/matching.c
  misc/microscopic_update.c
  misc/mixing.c
  misc/motifs.c
  misc/other.c
  misc/scan.c
  misc/sir.c
  misc/spanning_trees.c

  internal/glpk_support.c
  internal/hacks.c
  internal/lsap.c
  internal/qsort_r.c
  internal/qsort.c
  internal/zeroin.c

  version.c

  # Vendored library sources. Yes, this is horrible.
  $<IF:$<OR:$<BOOL:${ARPACK_IS_VENDORED}>,$<BOOL:${BLAS_IS_VENDORED}>,$<BOOL:${LAPACK_IS_VENDORED}>>,$<TARGET_OBJECTS:f2c_vendored>,>
  $<IF:$<BOOL:${ARPACK_IS_VENDORED}>,$<TARGET_OBJECTS:arpack_vendored>,>
  $<IF:$<BOOL:${BLAS_IS_VENDORED}>,$<TARGET_OBJECTS:blas_vendored>,>
  $<IF:$<BOOL:${CXSPARSE_IS_VENDORED}>,$<TARGET_OBJECTS:cxsparse_vendored>,>
  $<IF:$<BOOL:${GLPK_IS_VENDORED}>,$<TARGET_OBJECTS:glpk_vendored>,>
  $<IF:$<BOOL:${GMP_IS_VENDORED}>,$<TARGET_OBJECTS:gmp_vendored>,>
  $<IF:$<BOOL:${LAPACK_IS_VENDORED}>,$<TARGET_OBJECTS:lapack_vendored>,>
  $<IF:$<BOOL:${PLFIT_IS_VENDORED}>,$<TARGET_OBJECTS:plfit_vendored>,>
)

# Set soname for the library
set_target_properties(igraph PROPERTIES VERSION "0.0.0")
set_target_properties(igraph PROPERTIES SOVERSION 0)

# Add extra compiler definitions if needed
target_compile_definitions(
  igraph
  PRIVATE
  IGRAPH_VERIFY_FINALLY_STACK=$<IF:$<BOOL:${IGRAPH_VERIFY_FINALLY_STACK}>,1,0>
)

# Make sure that a macro named IGRAPH_FILE_BASENAME is provided in every
# compiler call so we can use these in debug messages without revealing the
# full path of the file on the machine where it was compiled
define_file_basename_for_sources(igraph)

# Add include path. Includes are in ../include but they get installed to
# <prefix>/include/igraph, hence the two options. We also have some private
# includes that are generated at compile time but are not part of the public
# interface.
target_include_directories(
  igraph
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/igraph>
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/vendor

  # Vendored library include paths
  $<$<BOOL:${CXSPARSE_IS_VENDORED}>:$<TARGET_PROPERTY:cxsparse_vendored,INCLUDE_DIRECTORIES>>
  $<$<BOOL:${GLPK_IS_VENDORED}>:$<TARGET_PROPERTY:glpk_vendored,INCLUDE_DIRECTORIES>>
  $<$<BOOL:${PLFIT_IS_VENDORED}>:$<TARGET_PROPERTY:plfit_vendored,INCLUDE_DIRECTORIES>>

  # Include paths for dependencies
  $<$<BOOL:${CXSPARSE_INCLUDE_DIRS}>:${CXSPARSE_INCLUDE_DIRS}>
  $<$<BOOL:${GLPK_INCLUDE_DIR}>:${GLPK_INCLUDE_DIR}>
  $<$<BOOL:${GMP_INCLUDE_DIR}>:${GMP_INCLUDE_DIR}>
  $<$<BOOL:${LIBXML2_INCLUDE_DIRS}>:${LIBXML2_INCLUDE_DIRS}>
  $<$<BOOL:${PLFIT_INCLUDE_DIRS}>:${PLFIT_INCLUDE_DIRS}>
)

if(MATH_LIBRARY)
  target_link_libraries(igraph PUBLIC ${MATH_LIBRARY})
endif()

if(ARPACK_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${ARPACK_LIBRARIES})
endif()

if(BLAS_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${BLAS_LIBRARIES})
endif()

if(CXSPARSE_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${CXSPARSE_LIBRARIES})
endif()

if(GLPK_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${GLPK_LIBRARIES})
endif()

if(GMP_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${GMP_LIBRARIES})
endif()

if(LAPACK_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${LAPACK_LIBRARIES})
endif()

if(LIBXML2_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${LIBXML2_LIBRARIES})
endif()

if(PLFIT_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${PLFIT_LIBRARIES})
endif()

# Link igraph statically to some of the libraries from the subdirectories
target_link_libraries(
  igraph
  PRIVATE
  bliss cliquer prpack
)

# Disable complex number support for CXSparse because:
#   - It is necessary to compile with MSVC
#   - igraph does not need complex number support from CXSparse on any platform
# This is needed here (in addition to the cxsparse_vendored target) because
# igraph may be compiled with an external CXSparse.
target_compile_definitions(igraph PRIVATE NCOMPLEX)

if (NOT BUILD_SHARED_LIBS)
  target_compile_definitions(igraph PRIVATE IGRAPH_STATIC)
else()
  target_compile_definitions(igraph PRIVATE igraph_EXPORTS)
endif()

if(MSVC)
  # Add MSVC-specific include path for some headers that are missing on Windows
  target_include_directories(igraph PRIVATE ${PROJECT_SOURCE_DIR}/msvc/include)
endif()

# Turn on all warnings for GCC, clang and MSVC
use_all_warnings(igraph)

# GNUInstallDirs be included before generating the pkgconfig file, as it defines
# CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR variables.
include(GNUInstallDirs)

# Generate pkgconfig file
include(pkgconfig_helpers)

include(GenerateExportHeader)
generate_export_header(igraph
  STATIC_DEFINE IGRAPH_STATIC
  EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/include/igraph_export.h
)

# Provide an igraph-config.cmake file in the installation directory so
# users can find the installed igraph library with FIND_PACKAGE(igraph)
# from their CMakeLists.txt files
include(CMakePackageConfigHelpers)
configure_package_config_file(
  ${PROJECT_SOURCE_DIR}/etc/cmake/igraph-config.cmake.in
  ${PROJECT_BINARY_DIR}/igraph-config.cmake
  # Install destination selected according to https://wiki.debian.org/CMake
  # and by looking at how eigen3 does it in Ubuntu
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/igraph
)
write_basic_package_version_file(
  ${PROJECT_BINARY_DIR}/igraph-config-version.cmake
  VERSION ${PACKAGE_VERSION_BASE}
  COMPATIBILITY SameMinorVersion
)

# Define how to install the library
install(
  TARGETS igraph bliss cliquer prpack
  EXPORT igraph_targets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}

=== vendor/CMakeLists.txt ===
add_subdirectory(cs)
add_subdirectory(f2c)
add_subdirectory(glpk)
add_subdirectory(lapack)
add_subdirectory(mini-gmp)
add_subdirectory(plfit)

=== src/cliques/cliquer/CMakeLists.txt ===
# Declare the files needed to compile Cliquer
add_library(
  cliquer
  OBJECT
  EXCLUDE_FROM_ALL
  cliquer.c
  cliquer_graph.c
  reorder.c
)

target_include_directories(
  cliquer
  PRIVATE
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_BINARY_DIR}/src
)

if (BUILD_SHARED_LIBS)
  set_property(TARGET cliquer PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

# Since these are included as object files, they should call the
# function as is (without visibility specification)
target_compile_definitions(cliquer PRIVATE IGRAPH_STATIC)

# TODO(ntamas): make sure that this works for Cliquer
# use_all_warnings(cliquer)

=== debian/changelog ===
igraph (0.9.6+ds-2ubuntu1) jammy; urgency=medium

  * Package new upstream (LP: #1962195)
  * Keep the following change:
    - Run autopkg tests with allow-stderr

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Thu, 24 Feb 2022 14:54:08 +0100

igraph (0.9.6+ds-2) unstable; urgency=medium

  * Source only upload
  * Add missing build dependency on dh addon.
  * Add two missing symbols in symbols file

 -- Andreas Tille <tille@debian.org>  Sat, 08 Jan 2022 21:50:51 +0100

igraph (0.9.6+ds-1) unstable; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/aptches/*:
      - d/p/debianization{,-suitesparse-header_folder}.patch, update;
      - d/p/upstream-external-plfit.patch, refresh;
      - d/p/8c5711d8d143a40602dbd177f1a343471304efa7.patch, obsoleted.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 06 Jan 2022 09:29:26 +0000

igraph (0.9.5+ds-3) unstable; urgency=medium

  * Debianization:
    - d/copyright, update copyright year tuples;
    - d/adhoc/examples/*/Makfile, idem;
    - d/patches/*:
      - d/p/upstream-external-plfit.patch, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 04 Jan 2022 20:46:03 +0000

igraph (0.9.5+ds-2) unstable; urgency=medium

  * Fix watchfile (comment) to detect new versions on github
  * cme fix dpkg-control
  * Fix test suite on i386 (see upstream issue #1894)

 -- Andreas Tille <tille@debian.org>  Sun, 19 Dec 2021 08:28:23 +0100

igraph (0.9.5+ds-1) experimental; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, now discard vendor/plfit;
    - d/control:
      - Build-Depends field, add libplfit-dev;
    - d/tests/control:
      - Depends field for benchmarks test, add libplfit-dev;
    - d/rules:
      - override_dh_install-indep target, update;
      - override_dh_fixterm target, obsoleted;
    - d/patches/upstream-external-plfit.patch, introduce;
    - d/adhoc/adhoc/examples/{simple,tutorial}/Makefile,
        add option -Wno-maybe-uninitialized to CFLAGS;
    - d/libigraph-doc.docs, introduce;
    - d/libigraph2.symbols, refresh;
    - d/README.Debian, obsoleted.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 14 Nov 2021 20:24:31 +0000

igraph (0.9.4+ds-3) experimental; urgency=medium

  * Debianization:
    - d/control:
      - Build-Depends-Indep, add python3;
    - d/copyright, harden.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 03 Nov 2021 21:04:55 +0000

igraph (0.9.4+ds-2) experimental; urgency=medium

  * FTBFS fix release: the new major upstream version appears to build
    successfully with gcc-11 (Closes: #984058).
  * Debianization:
    - d/rules, fix typo in CONF_FLAGS;
    - d/control:
      - Standards-Version, dump to 4.6.0 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 11 Oct 2021 19:53:51 +0000

igraph (0.9.4+ds-1) experimental; urgency=medium

  * New upstream minor version (minor changes)
  * Debianization;
    - d/copyright:
      - Files-Excluded field, refresh;
    - d/watch, update;
    - d/rules:
      - override_dh_install-indep target, update;
    - d/libigraph-dev.install, install (new) cmake material;
    - d/libigraph-doc.{install,doc-base}, now manage PDF manual;
    - d/libigraph2.symbols, introduce;
    - d/s/lintian-overrides, introduce;
    - d/a/e/b/Makefile, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 18 Jul 2021 11:18:58 +0000

igraph (0.9.1+ds1-1) UNRELEASED; urgency=medium

  * New upstream minor version (major changes)
  * Debianization:
    - d/control:
      - SO version, bump to version 2;
      - Build-Depends-Indep field, introduce;
      - Build-Depends field:
        - cmake, add (migration to cmake);
        - jdupes, discard (no more needed);
      - Package libigraph2:
        - introduce (bumped SO version, see above);
        - Conflicts and Replaces fields, discard;
      - Package libigraph-examples, renamed libigraph-doc;
    - d/copyright:
      - Files-Excluded field, refresh;
      - Debian Files:
        - copyright, add myself;
      - refresh;
    - d/rules:
      - migrate from autotools to cmake;
      - refresh;
    - d/clean, discard;
    - d/tests:
      - d/t/control:
        - internal tests check, discard;
        - tutorial check, introduce;
      - d/t/check, set simple as default;
    - d/patches:
      - d/p/upstream-fix-examples_benchmarks_bench_h-missing-include.patch,
        integrated;
      - d/p/upstream-fix-examples_simple-gcc-warnings.patch, integrated;
      - d/p/upstream-fix-lintian-spelling_error_in_binary.patch, refresh;
      - d/p/upstream-fixed-{git-interfer-nomore,cmake-check,XSOVERSION},patch,
        fixed by and imported from upstream (thanks to upstream team);
      - d/p/debianization{,-doc-local_fonts}.patch, introduce;
      - d/p/soversion.patch, SO version manage via d/p/debianization.patch;
      - d/p/upstream-enhance-external_suitesparse.patch, obsoleted;
      - d/p/do_not_make_anything_in_doc.patch, obsoleted;
      - d/p/enable_removing_third_party_code.patch, obsoleted;
    - d/adhoc/examples/*, refresh;
    - d/libigraph-dev.manpages, introduce;
    - d/libigraph-doc.{install,doc-base}, introduce;
    - d/libigraph1.symbols.amd64, temporarily discard (new and not fixed ABI);
    - d/libigraph-examples.links, obsoleted.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 12 Apr 2021 18:36:28 +0000

igraph (0.8.5+ds1-1ubuntu1) impish; urgency=medium

  * Run autopkg tests with allow-stderr, new compiler warnings.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Aug 2021 12:28:26 +0200

=== debian/control ===
Source: igraph
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSCB-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.16),
               d-shlibs,
               libtool,
               bison,
               flex,
               libxml2-dev,
               libplfit-dev,
               libgmp-dev,
               libarpack2-dev,
               libblas-dev,
               liblapack-dev,
               libsuitesparse-dev,
               libglpk-dev (>= 5.0),
               libf2c2-dev,
               liblzma-dev,
               debhelper
Build-Depends-Indep: python3,
                     xmlto,
                     source-highlight,
                     fop,
                     fonts-font-awesome
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/igraph
Vcs-Git: https://salsa.debian.org/med-team/igraph.git
Homepage: https://igraph.org/c/
Rules-Requires-Root: no

Package: libigraph2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for creating and manipulating graphs
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This is the runtime library package.

Package: libigraph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libigraph2 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Suggests: libigraph-doc,
          pkg-config
Description: library for creating and manipulating graphs - development files
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This package contains the include files and static library for the igraph
 C library.

Package: libigraph-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-font-awesome,
         ${misc:Depends}
Suggests: libigraph-dev (= ${binary:Version}),
          libsuitesparse-dev,
          www-browser
Breaks: libigraph-examples (<< 0.9)
Replaces: libigraph-examples (<< 0.9)
Description: library for creating and manipulating graphs - reference manual
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This package provides the reference manual for the igraph C library;
 it also contains examples and tutorial material.

Package: libigraph-examples
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends: libigraph-doc,
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDIR_STATIC=_BUILD_STATIC
BUILDIR_SHARED=_BUILD_SHARED

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDIR_SHARED)

#	--enable-debug

### disable TLS to fix warning with TLS and arpack
CONF_FLAGS=\
	-DIGRAPH_ENABLE_LTO=ON \
	-DIGRAPH_ENABLE_TLS=OFF \
	-DIGRAPH_USE_INTERNAL_BLAS=OFF \
	-DIGRAPH_USE_INTERNAL_LAPACK=OFF \
	-DIGRAPH_USE_INTERNAL_ARPACK=OFF \
	-DIGRAPH_USE_INTERNAL_GLPK=OFF \
	-DIGRAPH_USE_INTERNAL_CXSPARSE=OFF \
	-DIGRAPH_USE_INTERNAL_GMP=OFF \
	-DIGRAPH_USE_INTERNAL_PLFIT=OFF \
	-DIGRAPH_GLPK_SUPPORT=ON \
	-DIGRAPH_GRAPHML_SUPPORT=ON \
	-DIGRAPH_OPENMP_SUPPORT=ON

override_dh_auto_configure:
	dh_auto_configure -B$(BUILDIR_SHARED) -- -DBUILD_SHARED_LIBS=ON  $(CONF_FLAGS)
	dh_auto_configure -B$(BUILDIR_STATIC) -- -DBUILD_SHARED_LIBS=OFF $(CONF_FLAGS)

override_dh_auto_build-indep:
	make -C $(BUILDIR_SHARED)/doc pdf
	make -C $(BUILDIR_SHARED)/doc html
	mv -v $(BUILDIR_SHARED)/doc/igraph-docs.pdf $(BUILDIR_SHARED)/doc/igraph.pdf
	make -C $(BUILDIR_SHARED)/doc clean

override_dh_auto_build-arch:
	dh_auto_build -a -B$(BUILDIR_STATIC)
	dh_auto_build -a -B$(BUILDIR_SHARED)

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	dh_auto_test -a -B$(BUILDIR_STATIC)
	dh_auto_test -a -B$(BUILDIR_SHARED)

override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install -a -B$(BUILDIR_STATIC)
	dh_auto_install -a -B$(BUILDIR_SHARED)

UPS_VERSION := $(firstword $(subst +, ,$(DEB_VERSION)))
DEB_DH_INSTALL_INDEP_DOCDIR := $(CURDIR)/debian/libigraph-doc/usr/share/doc/libigraph-dev
DEB_DH_INSTALL_INDEP_EXAMPLESDIR := $(DEB_DH_INSTALL_INDEP_DOCDIR)/examples
override_dh_install-indep:
	dh_install -i
	cp -vp -t $(DEB_DH_INSTALL_INDEP_EXAMPLESDIR)/simple $(CURDIR)/tests/unit/test_utilities.inc
	find $(DEB_DH_INSTALL_INDEP_EXAMPLESDIR)/simple -name '*.c'   -exec sed -i 's|../../tests/unit/test_utilities.inc|test_utilities.inc|' \{\} \;
	find $(DEB_DH_INSTALL_INDEP_EXAMPLESDIR)/simple -name '*.out' -exec sed -i 's|@VERSION@|$(UPS_VERSION)|' \{\} \;

override_dh_installchangelogs:
	dh_installchangelogs --keep CHANGELOG.md

override_dh_compress-indep:
	dh_compress -X/examples/

override_dh_missing:
	dh_missing -X.la

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDIR_SHARED) $(BUILDIR_STATIC)

=== debian/tests/control ===
Test-Command: debian/tests/check simple
Depends: libigraph-dev, libsuitesparse-dev, libigraph-doc, build-essential, pkg-config
Restrictions: allow-stderr

Test-Command: debian/tests/check tutorial
Depends: libigraph-dev, libigraph-doc, build-essential, pkg-config
Restrictions: allow-stderr

Test-Command: debian/tests/check benchmarks
Depends: libigraph-dev, libplfit-dev, libigraph-doc, build-essential, pkg-config
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="repacksuffix=+ds,dversionmangle=s/\+ds[\d]?//,repack,compression=xz" \
  https://igraph.org/c/#downloads .*/releases/download/.*/igraph-(\d[\d.-]+)\.tar\.gz

# see https://github.com/igraph/igraph/issues/1377#issuecomment-620620166
#  https://github.com/igraph/igraph/releases .*/(\d[\d.-]+)\.tar\.gz

## igraph 0.9.9+ds

=== debian/changelog ===
igraph (0.9.9+ds-1) unstable; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/watch, now download directly from github.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 04 Jun 2022 12:45:17 +0000

igraph (0.9.8+ds-1) unstable; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/libigraph2.symbols, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 09 Apr 2022 13:45:34 +0000

igraph (0.9.7+ds-1) unstable; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/rules:
      - explicitly disable LTO for the static library as LTO does
        not really achieve anything for static libraries (thanks to
        Timo Röhling <roehling@debian.org> for the hint).
    - d/patches/*:
      - d/p/upstream-external-plfit.patch, update (partially integrated).

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 16 Mar 2022 23:11:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: igraph
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSCB-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Jerome Benoit <calculus@rezozer.net>,
            Andreas Tille <tille@debian.org>
 Section: science

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,7 @@
 #	--enable-debug
 
 ### disable TLS to fix warning with TLS and arpack
-CONF_FLAGS=\
-	-DIGRAPH_ENABLE_LTO=ON \
+CONF_FLAGS= \
 	-DIGRAPH_ENABLE_TLS=OFF \
 	-DIGRAPH_USE_INTERNAL_BLAS=OFF \
 	-DIGRAPH_USE_INTERNAL_LAPACK=OFF \
@@ -27,9 +26,11 @@
 	-DIGRAPH_GRAPHML_SUPPORT=ON \
 	-DIGRAPH_OPENMP_SUPPORT=ON
 
+
+### LTO does not really achieve anything for static libraries
 override_dh_auto_configure:
-	dh_auto_configure -B$(BUILDIR_SHARED) -- -DBUILD_SHARED_LIBS=ON  $(CONF_FLAGS)
-	dh_auto_configure -B$(BUILDIR_STATIC) -- -DBUILD_SHARED_LIBS=OFF $(CONF_FLAGS)
+	dh_auto_configure -B$(BUILDIR_SHARED) -- -DIGRAPH_ENABLE_LTO=ON  -DBUILD_SHARED_LIBS=ON  $(CONF_FLAGS)
+	dh_auto_configure -B$(BUILDIR_STATIC) -- -DIGRAPH_ENABLE_LTO=OFF -DBUILD_SHARED_LIBS=OFF $(CONF_FLAGS)
 
 override_dh_auto_build-indep:
 	make -C $(BUILDIR_SHARED)/doc pdf

=== debian/tests/control ===
Test-Command: debian/tests/check simple
Depends: libigraph-dev, libsuitesparse-dev, libigraph-doc, build-essential, pkg-config

Test-Command: debian/tests/check tutorial
Depends: libigraph-dev, libigraph-doc, build-essential, pkg-config

Test-Command: debian/tests/check benchmarks
Depends: libigraph-dev, libplfit-dev, libigraph-doc, build-essential, pkg-config

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=s/\+ds[\d]?//,repack,compression=xz" \
	https://github.com/igraph/igraph/releases .*/igraph-(\d[\d.-]+)\.tar\.gz

# see https://github.com/igraph/igraph/issues/1377#issuecomment-620620166
#  https://github.com/igraph/igraph/releases .*/(\d[\d.-]+)\.tar\.gz
#  https://igraph.org/c/#downloads .*/releases/download/.*/igraph-(\d[\d.-]+)\.tar\.gz
